## ros-noetic-mcl-3dl 0.6.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1.3)
project(mcl_3dl)

set(CATKIN_DEPENDS
  roscpp

  pcl_ros
  tf2
  tf2_geometry_msgs
  tf2_ros
  tf2_sensor_msgs

  diagnostic_updater
  geometry_msgs
  mcl_3dl_msgs
  nav_msgs
  sensor_msgs
  std_msgs
  std_srvs
  visualization_msgs
)

find_package(catkin REQUIRED COMPONENTS ${CATKIN_DEPENDS})
find_package(Eigen3 REQUIRED)
find_package(PCL 1.8.0 REQUIRED
  COMPONENTS
    core
    filters
    kdtree
)
find_package(Boost REQUIRED COMPONENTS chrono)
catkin_package(
  INCLUDE_DIRS include
  CATKIN_DEPENDS ${CATKIN_DEPENDS}
)

set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

include_directories(include ${catkin_INCLUDE_DIRS} ${EIGEN3_INCLUDE_DIR} ${Boost_INCLUDE_DIRS} ${PCL_INCLUDE_DIR})
add_definitions(${PCL_DEFINITIONS})


# Workaround for debian stretch build (https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=894656)
list(REMOVE_ITEM PCL_LIBRARIES
  "vtkGUISupportQt"
  "vtkGUISupportQtOpenGL"
  "vtkGUISupportQtSQL"
  "vtkGUISupportQtWebkit"
  "vtkViewsQt"
  "vtkRenderingQt"
)

# Workaround for the bug in PCL<1.8.1 (https://github.com/PointCloudLibrary/pcl/issues/1406)
remove_definitions(-DDISABLE_LIBUSB-1.0)

# Workaround for PCL-1.7 problem on C++11 (https://github.com/PointCloudLibrary/pcl/issues/619)
# Debug build without optimization causes Segmentation fault.
# Set default build type to Release and add -O1 to CXX_FLAGS_DEBUG.
if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release)
endif()
set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -O1")

# Binary installed pcl provided by Linux distro is built with -march=native
# which causes a lot of compatibility problems.
# Define PCL_NO_PRECOMPILE to disable using the binary version.
add_definitions(-DPCL_NO_PRECOMPILE)


add_executable(mcl_3dl
  src/cloud_accum.cpp
  src/lidar_measurement_model_beam.cpp
  src/lidar_measurement_model_likelihood.cpp
  src/mcl_3dl.cpp
  src/parameters.cpp
  src/point_types.cpp
)
target_link_libraries(mcl_3dl ${catkin_LIBRARIES} ${Boost_LIBRARIES} ${PCL_LIBRARIES})
add_dependencies(mcl_3dl ${catkin_EXPORTED_TARGETS})


if(CATKIN_ENABLE_TESTING)
  find_package(rostest REQUIRED)
  find_package(rosunit REQUIRED)
  add_subdirectory(test)

  if(NOT "$ENV{ROS_DISTRO}" STREQUAL "melodic")
    find_package(roslint REQUIRED)
    roslint_cpp()
    roslint_add_test()
  endif()
endif()


install(TARGETS mcl_3dl
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)
install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
)
install(DIRECTORY launch config
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)

=== test/CMakeLists.txt ===
catkin_add_gtest(test_chunked_kdtree src/test_chunked_kdtree.cpp)
target_link_libraries(test_chunked_kdtree ${catkin_LIBRARIES} ${PCL_LIBRARIES})
catkin_add_gtest(test_cloud_accum src/test_cloud_accum.cpp ../src/cloud_accum.cpp)
target_link_libraries(test_cloud_accum ${catkin_LIBRARIES})
catkin_add_gtest(test_filter src/test_filter.cpp)
target_link_libraries(test_filter ${catkin_LIBRARIES})
catkin_add_gtest(test_nd src/test_nd.cpp)
target_link_libraries(test_nd ${catkin_LIBRARIES})
catkin_add_gtest(test_pf src/test_pf.cpp)
target_link_libraries(test_pf ${catkin_LIBRARIES})
catkin_add_gtest(test_point_types src/test_point_types.cpp)
target_link_libraries(test_point_types ${catkin_LIBRARIES} ${PCL_LIBRARIES})
catkin_add_gtest(test_point_cloud_random_sampler src/test_point_cloud_random_sampler.cpp)
target_link_libraries(test_point_cloud_random_sampler ${catkin_LIBRARIES} ${PCL_LIBRARIES})
catkin_add_gtest(test_quat src/test_quat.cpp)
target_link_libraries(test_quat ${catkin_LIBRARIES})
catkin_add_gtest(test_raycast src/test_raycast.cpp)
target_link_libraries(test_raycast ${catkin_LIBRARIES} ${PCL_LIBRARIES})
catkin_add_gtest(test_raycast_dda src/test_raycast_dda.cpp)
target_link_libraries(test_raycast_dda ${catkin_LIBRARIES} ${PCL_LIBRARIES})
catkin_add_gtest(test_state_6dof src/test_state_6dof.cpp)
target_link_libraries(test_state_6dof ${catkin_LIBRARIES})
catkin_add_gtest(test_vec3 src/test_vec3.cpp)
target_link_libraries(test_vec3 ${catkin_LIBRARIES})
catkin_add_gtest(test_imu_measurement_model_gravity src/test_imu_measurement_model_gravity.cpp)
target_link_libraries(test_imu_measurement_model_gravity ${catkin_LIBRARIES})
catkin_add_gtest(test_motion_prediction_model_differential_drive src/test_motion_prediction_model_differential_drive.cpp)
target_link_libraries(test_motion_prediction_model_differential_drive ${catkin_LIBRARIES})
catkin_add_gtest(test_noise_generator src/test_noise_generator.cpp)
target_link_libraries(test_noise_generator ${catkin_LIBRARIES})
catkin_add_gtest(test_point_cloud_random_sampler_with_normal src/test_point_cloud_random_sampler_with_normal.cpp)
target_link_libraries(test_point_cloud_random_sampler_with_normal ${catkin_LIBRARIES})

add_executable(performance_raycast src/performance_raycast.cpp)
target_link_libraries(performance_raycast ${catkin_LIBRARIES} ${Boost_LIBRARIES} ${PCL_LIBRARIES})

add_rostest_gtest(test_debug_output tests/debug_output_rostest.test
    src/test_debug_output.cpp)
target_link_libraries(test_debug_output ${catkin_LIBRARIES})
add_dependencies(test_debug_output mcl_3dl)

add_rostest_gtest(test_expansion_resetting tests/expansion_resetting_rostest.test
    src/test_expansion_resetting.cpp)
target_link_libraries(test_expansion_resetting ${catkin_LIBRARIES})
add_dependencies(test_expansion_resetting mcl_3dl)

add_rostest_gtest(test_beam_label tests/beam_label_rostest.test
    src/test_beam_label.cpp)
target_link_libraries(test_beam_label ${catkin_LIBRARIES})
add_dependencies(test_beam_label mcl_3dl)

add_rostest_gtest(test_beam_likelihood tests/beam_likelihood_rostest.test
    src/test_beam_likelihood.cpp
    ../src/lidar_measurement_model_beam.cpp
    ../src/point_types.cpp
)
target_link_libraries(test_beam_likelihood ${catkin_LIBRARIES} ${PCL_LIBRARIES})

add_rostest_gtest(test_global_localization tests/global_localization_rostest.test
    src/test_global_localization.cpp)
target_link_libraries(test_global_localization ${catkin_LIBRARIES})
add_dependencies(test_global_localization mcl_3dl)

add_rostest_gtest(test_landmark tests/landmark_rostest.test
    src/test_landmark.cpp)
target_link_libraries(test_landmark ${catkin_LIBRARIES})
add_dependencies(test_landmark mcl_3dl)

add_rostest_gtest(test_mcl_3dl_compat tests/mcl_3dl_compat_rostest.test
    src/test_mcl_3dl_compat.cpp)
target_link_libraries(test_mcl_3dl_compat ${catkin_LIBRARIES})

add_rostest_gtest(test_transform_failure tests/transform_rostest.test
    src/test_transform_failure.cpp)
target_link_libraries(test_transform_failure ${catkin_LIBRARIES})
add_dependencies(test_transform_failure mcl_3dl)

if(MCL_3DL_EXTRA_TESTS)

  catkin_download_test_data(
      ${PROJECT_NAME}_short_test3.bag
      https://openspur.org/~atsushi.w/dataset/mcl_3dl/short_test3.bag
      MD5 7f0f4a2c2c4d569c81cb972d7dc30ca0
      FILENAME test/short_test3.bag)

  catkin_download_test_data(
      ${PROJECT_NAME}_short_test_ref.topic
      https://openspur.org/~atsushi.w/dataset/mcl_3dl/short_test_ref.topic
      MD5 6ad3b72f6c50952ad1120316d4702e71
      FILENAME test/short_test_ref.topic)

  configure_file(tests/localization_rostest.test.in
      ${PROJECT_BINARY_DIR}/test/tests/localization_rostest.test)
  configure_file(tests/tf_rostest.test.in
      ${PROJECT_BINARY_DIR}/test/tests/tf_rostest.test)

  add_executable(compare_pose
      src/compare_pose.cpp)
  target_link_libraries(compare_pose ${catkin_LIBRARIES} ${GTEST_LIBRARIES})
  add_dependencies(compare_pose
        ${PROJECT_NAME}_short_test3.bag
        ${PROJECT_NAME}_short_test_ref.topic
        mcl_3dl)

  add_rostest(${PROJECT_BINARY_DIR}/test/tests/localization_rostest.test
    DEPENDENCIES
      compare_pose
      ${PROJECT_NAME}_short_test3.bag
      ${PROJECT_NAME}_short_test_ref.topic
      mcl_3dl)
  add_rostest(${PROJECT_BINARY_DIR}/test/tests/localization_rostest.test
    ARGS without_imu:=true
    DEPENDENCIES
      compare_pose
      ${PROJECT_NAME}_short_test3.bag
      ${PROJECT_NAME}_short_test_ref.topic
      mcl_3dl)

  add_rostest_gtest(compare_tf ${PROJECT_BINARY_DIR}/test/tests/tf_rostest.test
      src/compare_tf.cpp)
  target_link_libraries(compare_tf ${catkin_LIBRARIES})
  add_dependencies(compare_tf
        ${PROJECT_NAME}_short_test3.bag
        ${PROJECT_NAME}_short_test_ref.topic
        mcl_3dl
      )

else()

  message("To perform extra heavy tests for mcl_3dl, use -DMCL_3DL_EXTRA_TESTS:=ON")

endif()

=== debian/changelog ===
ros-noetic-mcl-3dl (0.6.1-1buster) buster; urgency=high

  * Update assets to v0.4.1 (#400 <https://github.com/at-wat/mcl_3dl/issues/400>)
  * Support PCL 1.11 and later (#397 <https://github.com/at-wat/mcl_3dl/issues/397>)
  * Update assets to v0.4.0 (#395 <https://github.com/at-wat/mcl_3dl/issues/395>)
  * Update assets to v0.3.4 (#392 <https://github.com/at-wat/mcl_3dl/issues/392>)
  * Remove old workarounds for PCL<1.8 (#389 <https://github.com/at-wat/mcl_3dl/issues/389>)
  * Update assets to v0.3.3 (#388 <https://github.com/at-wat/mcl_3dl/issues/388>)
  * Update assets to v0.3.2 (#387 <https://github.com/at-wat/mcl_3dl/issues/387>)
  * Update code format (#386 <https://github.com/at-wat/mcl_3dl/issues/386>)
  * Contributors: Atsushi Watanabe

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Wed, 04 Jan 2023 00:00:00 -0000

ros-noetic-mcl-3dl (0.6.0-1buster) buster; urgency=high

  * Add option to load cloud through "load_pcd" service (#381 <https://github.com/at-wat/mcl_3dl/issues/381>)
  * Update assets to v0.3.1 (#382 <https://github.com/at-wat/mcl_3dl/issues/382>)
  * Update assets to v0.3.0 (#380 <https://github.com/at-wat/mcl_3dl/issues/380>)
  * Update assets to v0.2.0 (#379 <https://github.com/at-wat/mcl_3dl/issues/379>)
  * Contributors: Atsushi Watanabe, Remco

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Wed, 12 May 2021 00:00:00 -0000

ros-noetic-mcl-3dl (0.5.4-1buster) buster; urgency=high

  * Add odom/imu/cloud_queue_size params (#375 <https://github.com/at-wat/mcl_3dl/issues/375>)
  * Fix flaky tests (#376 <https://github.com/at-wat/mcl_3dl/issues/376>)
  * Contributors: Atsushi Watanabe

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Sun, 07 Mar 2021 00:00:00 -0000

ros-noetic-mcl-3dl (0.5.3-1buster) buster; urgency=high

  * Fix cloud accum reset on map update (#371 <https://github.com/at-wat/mcl_3dl/issues/371>)
  * Contributors: Atsushi Watanabe

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Fri, 26 Feb 2021 00:00:00 -0000

ros-noetic-mcl-3dl (0.5.2-1buster) buster; urgency=high

  * Fix potential "Time is out of dual 32-bit range" error (#367 <https://github.com/at-wat/mcl_3dl/issues/367>)
  * Update assets to v0.1.4 (#365 <https://github.com/at-wat/mcl_3dl/issues/365>)
  * Improve test stability (#363 <https://github.com/at-wat/mcl_3dl/issues/363>)
  * Update assets to v0.1.3 (#362 <https://github.com/at-wat/mcl_3dl/issues/362>)
  * Update assets to v0.1.2 (#361 <https://github.com/at-wat/mcl_3dl/issues/361>)
  * Migrate to GitHub Actions (#357 <https://github.com/at-wat/mcl_3dl/issues/357>)
  * Update assets to v0.0.10 (#356 <https://github.com/at-wat/mcl_3dl/issues/356>)
  * Contributors: Atsushi Watanabe

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Fri, 15 Jan 2021 00:00:00 -0000

ros-noetic-mcl-3dl (0.5.1-1buster) buster; urgency=high

  * Make hit_range independent from grid size and fix DDA hit/miss state (#350 <https://github.com/at-wat/mcl_3dl/issues/350>)
  * Fix crushing when lidar poses are out of map (#351 <https://github.com/at-wat/mcl_3dl/issues/351>)
  * Contributors: Atsushi Watanabe, Naotaka Hatao

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Mon, 26 Oct 2020 00:00:00 -0000

ros-noetic-mcl-3dl (0.5.0-1buster) buster; urgency=high

  * Fix crushing when new map is received (#347 <https://github.com/at-wat/mcl_3dl/issues/347>)
  * Ease condition for test of PointCloudSamplerWithNormal (#344 <https://github.com/at-wat/mcl_3dl/issues/344>)
  * Add faster raycast algorithm using DDA (#343 <https://github.com/at-wat/mcl_3dl/issues/343>)
  * Contributors: Naotaka Hatao

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Thu, 15 Oct 2020 00:00:00 -0000

ros-noetic-mcl-3dl (0.4.0-1buster) buster; urgency=high

  * Fix typos of license (#340 <https://github.com/at-wat/mcl_3dl/issues/340>)
  * Add PointCloudSamplerWithNormal (#339 <https://github.com/at-wat/mcl_3dl/issues/339>)
  * Contributors: Naotaka Hatao

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Wed, 07 Oct 2020 00:00:00 -0000

ros-noetic-mcl-3dl (0.3.0-1buster) buster; urgency=high

  * Switch beam model by map label field (#334 <https://github.com/at-wat/mcl_3dl/issues/334>)
  * Update test script for latest catkin (#333 <https://github.com/at-wat/mcl_3dl/issues/333>)
  * Remove references to sensor_msgs::PointCloud (#332 <https://github.com/at-wat/mcl_3dl/issues/332>)
  * Update assets to v0.0.9 (#331 <https://github.com/at-wat/mcl_3dl/issues/331>)
  * Improve expansion resetting/global localization test stability (#330 <https://github.com/at-wat/mcl_3dl/issues/330>)
  * Fix global localization test parameter (#328 <https://github.com/at-wat/mcl_3dl/issues/328>)
  * Avoid rate limit when fetching gh-ph-comment (#329 <https://github.com/at-wat/mcl_3dl/issues/329>)
  * Update gh-pr-comment (#327 <https://github.com/at-wat/mcl_3dl/issues/327>)
  * Retry codecov script download (#326 <https://github.com/at-wat/mcl_3dl/issues/326>)
  * Improve test coverage (#325 <https://github.com/at-wat/mcl_3dl/issues/325>)
  * Merge rostest coverage profiles (#324 <https://github.com/at-wat/mcl_3dl/issues/324>)
  * Contributors: Atsushi Watanabe, f-fl0

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Mon, 07 Sep 2020 00:00:00 -0000

ros-noetic-mcl-3dl (0.2.5-1buster) buster; urgency=high

  * Add validation for orientation of initial pose (#317 <https://github.com/at-wat/mcl_3dl/issues/317>)
  * Update CI scripts (#318 <https://github.com/at-wat/mcl_3dl/issues/318>)
  * Contributors: Atsushi Watanabe, Yuta Koga

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Wed, 27 May 2020 00:00:00 -0000

ros-noetic-mcl-3dl (0.2.4-1buster) buster; urgency=high

  * Fix resampling failure of last particle (#313 <https://github.com/at-wat/mcl_3dl/issues/313>)
  * Retry gpg keyserver on prerelease test (#312 <https://github.com/at-wat/mcl_3dl/issues/312>)
  * Add filter class for Vec3 (#311 <https://github.com/at-wat/mcl_3dl/issues/311>)
  * Refactor math functions (#310 <https://github.com/at-wat/mcl_3dl/issues/310>)


=== debian/control ===
Source: ros-noetic-mcl-3dl
Section: misc
Priority: optional
Maintainer: Atsushi Watanabe <atsushi.w@ieee.org>
Build-Depends: debhelper (>= 9.0.0), libeigen3-dev, ros-noetic-catkin, ros-noetic-diagnostic-updater, ros-noetic-geometry-msgs, ros-noetic-mcl-3dl-msgs, ros-noetic-nav-msgs, ros-noetic-pcl-ros, ros-noetic-roscpp, ros-noetic-roslint <!nocheck>, ros-noetic-rostest <!nocheck>, ros-noetic-rosunit <!nocheck>, ros-noetic-sensor-msgs, ros-noetic-std-msgs, ros-noetic-std-srvs, ros-noetic-tf2, ros-noetic-tf2-geometry-msgs, ros-noetic-tf2-ros, ros-noetic-tf2-sensor-msgs, ros-noetic-visualization-msgs
Homepage: 
Standards-Version: 3.9.2

Package: ros-noetic-mcl-3dl
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libeigen3-dev, ros-noetic-diagnostic-updater, ros-noetic-geometry-msgs, ros-noetic-mcl-3dl-msgs, ros-noetic-nav-msgs, ros-noetic-pcl-ros, ros-noetic-roscpp, ros-noetic-sensor-msgs, ros-noetic-std-msgs, ros-noetic-std-srvs, ros-noetic-tf2, ros-noetic-tf2-geometry-msgs, ros-noetic-tf2-ros, ros-noetic-tf2-sensor-msgs, ros-noetic-visualization-msgs
Description: 3-D/6-DOF localization for mobile robots with 3-D LIDAR(s)

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/noetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF -DCATKIN_ENABLE_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/noetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/noetic" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-noetic-mcl-3dl//opt/ros/noetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_install
